#!/usr/bin/env python3

# Software License Agreement (BSD License)
#
# Copyright (c) 2015, Robert Haschke
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
#  * Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#  * Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#  * Neither the name of Willow Garage, Inc. nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
# INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
# ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

import unittest


class TestMessageTreeModel(unittest.TestCase):

    def test_path_names(self):
        from rqt_py_common.message_tree_model import MessageTreeModel
        from rqt_py_common_test_interfaces.msg import Val, ArrayVal
        m = MessageTreeModel()
        m.add_message(ArrayVal())
        root = m.item(0).child(0)
        self.assertEqual(root._path, '/vals')
        for i in range(0, 5):
            child = root.child(i)
            self.assertEqual(child._path, '/vals[%s]' % i)
            child = child.child(0)
            self.assertEqual(child._path, '/vals[%s]/floats' % i)
            for j in range(0, 5):
                self.assertEqual(child.child(j)._path, '/vals[%s]/floats[%s]' % (i, j))
